%%%%%% The algorithm is made here purely for plotting two graphs
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Traing the algorithm for based on learning set of data
%  Data:  Read from all kept data files after running screening algorithm
%         see line 169 of the file 'results/screen.out'.  The algorithm reads
%         the minimum qualification 'lowb' from the file 'screen.m'
%  Approach:  First, extract features from accelation curves.  These
%         features are
%                accel1, accel4, accel8, velcity, atimer
%                local oscilation, local distance
%         Form feature matrix at all of the times that the minimum
%         qualifiation is passed.  Then, fit a probability model to get
%         a extra feature.  Finally, compute the frontiers of NT event
%         at each giver atimer.
%  Results:   trainout.mat  contains 'frontiers' matrix and minimum
%             qualification lower bound 'lowb'
%  Plots  :   plot the accelation curves for each events, if plot_flag=1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
%format long g;
%format bank;

%addpath /afs/isis.unc.edu/home/c/z/czhang/czhang/airbags/newdata
%addpath /home/jfan/airbags/newdata
addpath /net/laplace/d13/jfan/airbags/newdata


tic;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%     Preliminary and initial parameters       %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plot_flag  = 1;                         % data are plotted if 1
add_flag   = 1;                         % fitting additive model if 1
N  	= 0;   		      		% number of cases
aperc   = 1.2;                          % perc and value of thresholding 
					% (1.05 if use a different timer)
athresh = 5;                            % parameter for a atimer
epsilon = 0;                            % used to define timer
filename=[];
subset  =[];                            % indicator whether a case should
					% be a case used in learning
triga   =[];                            % collection of trigger time index
					% "a" stands for all cases
					% satisfying minimum conditions
Ya      =[];   				% 0 for trigger data; 
					% 1 for (kept) NT data
a1a   	=[];     			% acceleration(rawdata)  
a4a	=[];     			% data4
a8a	=[];     			% data8
ada     =[];                            % a - data2
vela	=[];     			% vel 
dista	=[];     			% dist
osca	=[];     			% osc
atimera=[];     			% acceleration timer  
atimer1a=[];     			% acceleration timer by value  
indexa  =[];                            % index of case numbers


fid=fopen('.filename.out','r');    %  filenames of all kept data sets 




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%         Reading Data and Forming matrix             %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

while 1                                 % loop through all data sets
   line = fgetl(fid); 
   if ~ischar(line), break, end;
   N=N+1;
   %%%%%%%%%%%%%%% Determining filenames and require time %%%%%%%%
   j=1;              			% length of filenames
   while line(j) ~= ' '
       j = j+1;
   end;
   fid1 = fopen(line(1:(j-1)),'r'); 
   time(N,:)=line(20:21);  		% required time to crash 

   %%%%%%%%%%%%%%%%%%%%% read data %%%%%%%%%%%%%%%%%%%%%%%%%%%
   for j=1:13
     fgetl(fid1);   			% skip the first 13 header lines 
   end;

   data=[];
   while 1 
     line1=fgetl(fid1);
     if ~ischar(line1), break, end
     data=str2mat(data,line1(8:17));
   end;
   fclose(fid1);

   data = data(2:size(data,1),:); 		% delete the first blank line
   data = str2num(data);    			% numerical data 
   accel= data(:,2);
   nobs = size(data,1);

   filename=str2mat(filename,[line  num2str(nobs)]);
   disp(['The ', num2str(N), '-th DataSet : ',line, num2str(nobs)]);

   %%%%%%%%%%%% Feature Extraction %%%%%%%%%%%%%%%%%%%%%%%%%%%
      %%%%%%%%%% filtering of data  %%%%%%%%%%%%%%%%%%%%%
      
   data0=[zeros(1,1);data(:,2)];  		% padding zero
   data2=data0(1:nobs);			        % average of 4 observations
   for j=2:2
     data2=data2+data0(j:(nobs+j-1));
   end;
   data2=data2/2;                 
      
   data0=[zeros(3,1);data(:,2)];  		% padding zero
   data4=data0(1:nobs);			        % average of 4 observations
   for j=2:4
     data4=data4+data0(j:(nobs+j-1));
   end;
   data4=data4/4;                 
      
   data0=[zeros(7,1);data(:,2)];  		% padding zero 
   data8=data0(1:nobs);				% average of 8 obs.
   for j=2:8
     data8=data8+data0(j:(nobs+j-1));
   end;
   data8=data8/8;                 

    Time = 0.94 + 1.25*(0:nobs-1);

    if N == 1
     subplot(2,2,1);
     plot(Time, accel);
     axis([0 nobs -5 30]);
     title('Non deployment event')
    elseif N == 2
     subplot(2,2,2);
     plot(Time, accel);
     axis([0 nobs -5 30]);
     title('Non deployment event')
    elseif N==3
     subplot(2,2,3);
     plot(Time, accel);
     axis([0 nobs -5 30]);
     title('Deployment required before 18 ms')
    else
     subplot(2,2,4);
     plot(Time, accel);
     axis([0 nobs -5 30]);
     title('Deployment required before 48 ms');
    end
end;                                            %end reading all data sets
   print -dps .nsf991.eps
